using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using System.Diagnostics;

namespace GridTestFilterBar
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DataView dvTest;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private Syncfusion.Windows.Forms.Grid.GridFilterBar theFilterBar;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(352, 224);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(84, 288);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(416, 72);
			this.label2.TabIndex = 4;
			this.label2.Text = "(none)";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 288);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 23);
			this.label1.TabIndex = 3;
			this.label1.Text = "Row Filter: ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 382);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			dvTest = ReturnATable().DefaultView;
			this.gridDataBoundGrid1.DataSource = dvTest;

			this.theFilterBar = new Syncfusion.Windows.Forms.Grid.GridFilterBar();
			this.theFilterBar.WireGrid(gridDataBoundGrid1);
			this.theFilterBar.FilterBarTextChanged += new GridFilterBarTextChangedEventHandler(filterBar_FilterBarTextChanged);
		}

		private DataTable ReturnATable()
		{
			DataTable table = new DataTable("People");
			//Add two columns.
			table.Columns.Add(new DataColumn("FirstName"));
			table.Columns.Add(new DataColumn("LastName"));

			//Add some rows.
			DataRow dr = table.NewRow();
			dr["FirstName"] = "John";
			dr["LastName"] = "Smith";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "Mary";
			dr["LastName"] = "Tucker";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "Sue";
			dr["LastName"] = "Gaskins";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "John";
			dr["LastName"] = "Jacobs";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "Sam";
			dr["LastName"] = "Garfunkel";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "George";
			dr["LastName"] = "Shepherd";
			table.Rows.Add(dr);

			dr = table.NewRow();
			dr["FirstName"] = "Becky";
			dr["LastName"] = "Dunsford";
			table.Rows.Add(dr);
			
			return table;
		}

		private void filterBar_FilterBarTextChanged(object sender, GridFilterBarTextChangedEventArgs e)
		{
			if (theFilterBar.Wired)
			{
				Trace.Write("\n");
				Trace.Write("Data View row filter before unwire: " + dvTest.RowFilter + "\n");
				Trace.Write("FilterBar row filter before unwire: " + theFilterBar.RowFilter + "\n");

				theFilterBar.UnwireGrid();
				if (dvTest.RowFilter != "")
					dvTest.RowFilter = dvTest.RowFilter + " AND " + theFilterBar.RowFilter;
				else
					dvTest.RowFilter = theFilterBar.RowFilter;

				theFilterBar.RowFilter = "";
				theFilterBar.WireGrid(gridDataBoundGrid1);

				Trace.Write("\n");
				Trace.Write("Data View row filter after unwire : " + dvTest.RowFilter + "\n");
				Trace.Write("FilterBar row filter after unwire : " + theFilterBar.RowFilter + "\n");

				this.label2.Text = theFilterBar.RowFilter;
			}
		}
	}
}
